UNKNOWN_ERROR_ENGLISH = "UNKNOWN ERROR"

UNKNOWN_ERROR_CHINESE = "未知錯誤"

QR_TYPE_LIST = ["DUMMY","ALIPAY","WECHAT","UPIQR"]
SIGN_LIST = ["M","S","C","F","W","A","B"]
OCT_LAST_TOPUP_ENGLISH_LIST = [
    "","CASH","ONLINE","REFUND","AAVS","OTHERS"
]

OCT_LAST_TOPUP_CHINESE_LIST = [
    "","現金增值","線上增值","退款","自動增值","其他"
]

QR_CHINESE_MAP = {
	-2  : "無效金額",
	-3  : "無效支付碼",
	-4  : "無效收銀機參考編號",
	-5  : "沒有記錄",
	-11 : "沖正待處理",
	-12 : "連線錯誤",
	-13 : "交易已撤消",
	-14 : "交易超時或通訊錯誤",
	-16 : "回覆信息錯誤",
	-99 : "不知名錯誤",
	0  : "交易成功",
	1  : "查詢支付方",
	2  : "查詢服務商",
	3  : "商戶代號錯誤",
	4  : "未做實名認証",
	5  : "拒絕",
	6  : "錯誤",
	9  : "未開通無網絡支付",
	12 : "交易無效",
	13 : "金額錯誤",
	14 : "無效支付碼",
	19 : "超時-重做交易",
	20 : "無效交易",
	21 : "不作任何處理",
	22 : "懷疑操作有誤",
	23 : "不可接受的交易費",
	25 : "找不到原交易",
	26 : "買家操作未完成",
	28 : "不要重試",
	29 : "交易修改失敗",
	30 : "傳輸格式錯誤",
	31 : "網絡中斷",
	34 : "作弊嫌疑",
	36 : "受限制的帳戶",
	39 : "無此帳戶",
	41 : "帳戶已凍結",
	42 : "無此帳戶",
	43 : "非法支付碼",
	51 : "餘額不足",
	54 : "支付碼已過期",
	55 : "支付密碼錯",
	57 : "服務不支持",
	58 : "交易不允許",
	59 : "有作弊嫌疑",
	60 : "產品限額校驗未通過",
	61 : "超限額",
	62 : "服務代碼錯誤",
	63 : "支付碼校驗錯誤",
	64 : "原始金額不正確",
	65 : "限制使用",
	66 : "超當日限額",
	67 : "超當月限額",
	68 : "主機應答超時",
	69 : "超外匯兌換限額",
	75 : "支付密碼錯超限",
	76 : "產品代碼錯誤",
	77 : "結帳錯誤",
	78 : "追蹤碼錯誤",
	79 : "無效帳戶",
	80 : "數據錯誤",
	81 : "加密錯誤",
	83 : "密碼不能檢驗",
	84 : "未能連接支付方",
	85 : "正常帳戶",
	87 : "支付密碼處理錯",
	88 : "網絡故障",
	89 : "終端代碼錯誤",
	90 : "系統備份",
	91 : "支付方網絡錯誤",
	92 : "通訊錯誤",
	93 : "交易不能完成",
	94 : "序號重複",
	95 : "日切中請等待",
	96 : "系統故障",
	97 : "無此終端號",
	98 : "收不到支付方應答",
	99 : "密碼加密格式錯"
}

QR_ENGLISH_MAP = {
	-2 : "Invalid amount",
	-3 : "Invalid barcode",
	-4 : "Invalid ECR reference number",
	-5 : "No such record",
	-11: "Reversal Pending",
	-12: "Connection problem",
	-13: "Transaction already voided",
	-14: "Timeout",
	-16: "Error Response Message",
	-99: "Unknown error",
	0: "Transaction Approved",
	1: "Enquire Payment Processor",
	2: "Enquire Service Providers",
	3: "Invalid Merchant ID",
	4: "A/C Not Authenticated",
	5: "Declined",
	6: "Error",
	9: "No Network Payment Not Authorized",
	12 : "Invalid Transaction",
	13 : "Invalid Amount",
	14 : "Invalid Payment Code",
	19 : "Timeout – Retry Again",
	20 : "Invalid Transaction",
	21 : "No Processing",
	22 : "Operation Issues",
	23 : "Unacceptable Trans",
	25 : "Record Not Found",
	26 : "Buyer Operation Not Completed",
	28 : "Error – Do No Retry",
	29 : "Modification Failure",
	30 : "Transmission Format",
	31 : "Network Interruption",
	34 : "Fraud Suspected",
	36 : "Restricted Account",
	39 : "Invalid Account",
	41 : "Account Frozen",
	42 : "Invalid Account",
	43 : "Invalid Payment Code",
	51 : "Insufficient Fund",
	54 : "Payment Code Expired",
	55 : "Incorrect Payment Password",
	57 : "Unsupported Service",
	58 : "Transaction Not Allowed",
	59 : "Fraud Suspected",
	60 : "Exceed of The Payment Threshold of Product",
	61 : "Exceed Limit",
	62 : "Server Code Error",
	63 : "Payment Code Verification Failed",
	64 : "Incorrect Original Amount",
	65 : "Restricted",
	66 : "Exceed Daily Limit",
	67 : "Exceed Monthly Limit",
	68 : "Host Response Timeout",
	69 : "Over Currency Exchange Limitation",
	75 : "Payment Password retrial",
	76 : "Invalid Product Code",
	77 : "Settlement Error",
	78 : "Tracking Code Error",
	79 : "Invalid Account",
	80 : "Encryption Error",
	81 : "Password Unauthorized",
	83 : "Cannot Connect to Payment",
	84 : "Processor",
	85 : "Normal Account",
	87 : "Incorrect Payment PW Processing",
	88 : "Network Failure",
	89 : "Invalid Terminal Code",
	90 : "System Backup",
	91 : "Payment Processor Network Issue",
	92 : "Communication Error",
	93 : "Trans Not Completed",
	94 : "Duplicated Number",
	95 : "Daily Cut－Off – Please",
	96 : "Systems Error",
	97 : "Invalid Terminal ID",
	98 : "Response from Payment Processor",
	99 : "Invalid PW Encryption"
}

API_CHINESE_MAP = {
	"A10":"終端機沒有回應",
	"A11":"不能連接終端機",
	"A12":"輸入參數錯誤 ",
	"A13":"設定值錯誤",
	"A14":"終端機連接斷開",
	"E00":"沒有交易紀錄",
	"E01":"不能連接終端機",
	"E02":"用戶取消",
	"E03":"交易超時",
	"E04":"交易失敗",
	"E05":"終端機未準備",
	"E06":"無效ID",
	"E07":"MAC錯誤",
	"E08":"卡類錯誤",
	"E09":"不支持此交易",
	"E10":"連線失敗",
	"E11":"輸入超時",
	"E12":"功能不允許",
	"E13":"沖正待叔處理",
	"E14":"請初始化",
	"E15":"交易已消化",
	"E16":"終端機連接斷開",
	"E17":"ECR 未啟用",
	"E99":"交易未完成"
}

API_ENGLISH_MAP = {
	"A10":"No Response from Terminal",
	"A11":"Request Terminal Failure",
	"A12":"Input Parameter Error",
	"A13":"Properties Error",
	"A14":"Terminal disconnected during transaction",
	"E00":"RECORD NOT FOUND",
	"E01":"COMM ERROR",
	"E02":"Transaction Cancel",
	"E03":"Terminal Timeout",
	"E04":"TXN Failed",
	"E05":"TERMINAL BUSY",
	"E06":"Invalid ID",
	"E07":"MAC ERROR",
	"E08":"Card Type Mismatch",
	"E09":"TXN Not SUPP",
	"E10":"DIAL FAILED/CONNECT FAILED",
	"E11":"INPUT TIMEOUT",
	"E12":"FUNC NOT ALLOWED",
	"E13":"REVERSAL PENDING",
	"E14":"INITIALIZE REQUIRE",
	"E15":"TXN ALREADY VOIDED",
	"E16":"ECR COMM ERROR",
	"E17":"ECR DISABLE",
	"E99":"TXN Not APP"
}

HASE_LOYALTY_MAP = {
    "HSD":"HASE CASH$",
    "JDD":"enJoy$"
}

DCC_CURR_CODE_MAP = {
    "036" : "AUD",
    "124" : "CAD",
    "156" : "CNY",
    "196" : "CPY",
    "208" : "DKK",
    "344" : "HKD",
    "352" : "ISK",
    "356" : "INR",
    "360" : "IDR",
    "392" : "JPY",
    "410" : "KRW",
    "446" : "MOP",
    "458" : "MYR",
    "470" : "MTL",
    "554" : "NZD",
    "578" : "NOK",
    "608" : "PHP",
    "702" : "SGD",
    "710" : "ZAR",
    "752" : "SEK",
    "756" : "CHF",
    "764" : "THB",
    "826" : "GBP",
    "840" : "USD",
    "901" : "TWD",
    "978" : "EUR"
}

EPS_CHINESE_MAP = {
    '000':"接受",
    '400':"請聯絡易辦事",
    '401':"請聯絡易辦事",
    '402':"請聯絡易辦事",
    '403':"請聯絡易辦事",
    '404':"請聯絡易辦事",
    '410':"請聯絡易辦事",
    '413':"請聯絡易辦事",
    '414':"請聯絡易辦事",
    '427':"請聯絡易辦事",
    '428':"請聯絡易辦事",
    '405':"請重新操作",
    '409':"請重新操作",
    '411':"請重新操作",
    '412':"請重新操作",
    '415':"請與銀行聯絡",
    '420':"請與銀行聯絡",
    '416':"銀行系統故障",
    '421':"銀行系統故障",
    '417':"戶口已被取消",
    '418':"戶口選擇錯誤",
    '419':"此卡已失效",
    '422':"請查詢銀行",
    '423':"轉賬超過限額",
    '424':"密碼重按過限額",
    '425':"私人密碼錯誤",
    '426':"請重新操作",
    '444':"不接納此卡",
    '500':"請重新操作",
    '504':"請重新操作",
    '506':"請重新操作",
    '509':"請重新操作",
    '512':"請重新操作",
    '514':"請重新操作",
    '515':"請重新操作",
    '520':"請重新操作",
    '522':"請重新操作",
    '523':"請重新操作",
    '530':"請重新操作",
    '532':"請重新操作",
    '533':"請重新操作",
    '538':"請重新操作",
    '505':"請聯絡易辦事",
    '528':"請聯絡易辦事",
    '529':"請聯絡易辦事",
    '507':"其他原因",
    '508':"其他原因",
    '516':"其他原因",
    '517':"核對錯誤",
    '519':"其他原因",
    '535':"卡上資料錯誤",
    '536':"請重新操作",
    '537':"不接納此卡",
    '539':"其他原因",
    '541':"請重新操作",
    '542':"轉賬超過限額",
    '543':"其他原因",
    '550':"請結算 / 核賬",
    '557':"取款金額不符",
    '575':"請聯絡易辦事",
    '612':"其他原因",
    '613':"其他原因",
    '614':"其他原因",
    '645':"請聯絡易辦事",
    '646':"請聯絡易辦事",
    '900':"請重新操作",
    '902':"請重新操作",
    '901':"請重新操作",
    '909':"MAC錯誤"
}

EDC_RECEIPT_MAP = {
	"SALE":"銷售",
    "VOID":"撤銷",
    "REFUND":"退款",
    "RETRIEVAL":"查詢",
    "MID":"商戶號",
    "TID":"終端號",
    "DATE":"日期",
    "TIME":"時間",
    "BATCH":"批次號",
    "TRACE":"交易號",
    "PAN":"卡號",
    "EXPDATE":"有效期",
    "APPCODE":"授權碼",
    "REFNUM":"參考號",
    "TOTAL":"總計",
    "NET":"淨額",
    "SIGNATURE":"簽名",
    "NOSIGNATURE":"不需簽名",
    "ACCEPTED":"接受",
    "REJECTED":"不接受"
}

OCT_ENGLISH_MAP = {
    "TOPUP":"Octopus Add Value Service",
    "SALE":"Octopus payment",
    "ENQ":"Eligible Reward$",
    "TOTAL":"Amount deducted",
    "SUB_AMT":"Public Transport Fare Subsidy Amount",
    "SUBSIDY":"Public Transport Fare Subsidy",

    "NO_SUB1":"No uncollected public transport fare",
    "NO_SUB2":"subsidy. Please visit ptfss.gov.hk for",
    "NO_SUB3":"more details",

    "MAX_SUB1":"Your Octopus has reached the maximum",
    "MAX_SUB2":"stored value. There is uncollected ",
    "MAX_SUB3":"public transport fare subsidy of",
    "MAX_SUB4":", please try again later. Should you",
    "MAX_SUB5":"require assistance, please call Public",
    "MAX_SUB6":"Transport Fare Subsidy Scheme hotline",
    "MAX_SUB7":"2969-5500.",

    "REMAIN_SUB1":"There is uncollected public transport ",
    "REMAIN_SUB2":"fare subsidy of ",
    "REMAIN_SUB3":"please try again later. Should you ",
    "REMAIN_SUB4":"require assistance, please call Public",
    "REMAIN_SUB5":"Transport Fare Subsidy Scheme hotline",
    "REMAIN_SUB6":"2969-5500.",

    "REG_R":"Register now for Octopus Rewards at",

    "CHANGE_TITLE":"Octopus Top Up with Change Service"
}

OCT_CHINESE_MAP = {
	"SALE":"八達通付款",
    "TOPUP":"八達通增值服務",
    "REFUND":"退款",
    "MID":"商戶號",
    "TID":"機號",
    "OUTLET":"店號",
    "DATE":"日期",
    "TIME":"時間",
    "PAN":"八達通號碼",
    "TOTAL":"扣除金額",
    "NET":"扣除淨額",
    "ACCEPTED":"接受",
    "REJECTED":"不接受",
    "TOPUPVALUE":"增值金額",
    "REMINBAL":"餘額",
    "ENQ":" 查詢",
    "CASH":"現金增值",
    "AAVS":"自動增值",
    "ONLINE":"網上增值",
    "OTHER":"其他",
    "REDEEMED":"兌換日日賞$",
    "EARN":"賺取日日賞$",
    "R_BAL":"日日賞$餘額",
    "R_TITLE":"八達通日日賞",
    "SUB_AMT":"公共交通費用補貼金額",
    "SUBSIDY":"公共交通費用補貼",
    "ECRREF":"收據號碼",

    "NO_SUB1":"沒有未領取的公共交通費用補貼，",
    "NO_SUB2":"詳情可到ptfss.gov.hk 查詢。",

    "MAX_SUB1":"你的八達通儲值額已達上限，",
    "MAX_SUB2":"尚有未領取的公共交通費用補貼",
    "MAX_SUB3":"請稍後再試。如需協助請致電",
    "MAX_SUB4":"公共交通費用補貼計劃熱線",
    "MAX_SUB5":"2969-5500。",

    "REMAIN_SUB1":"尚有未領取的公共交通費用補貼 ",
    "REMAIN_SUB2":"請稍後再試。如需協助請致電",
    "REMAIN_SUB3":"公共交通費用補貼計劃熱線2969-5500。",

    "REG_R":"請即上網登記八達通日日賞",

    "CHANGE_TITLE":"八達通找續增值服務"
}

OCT_RESPONSE_CHINESE_MAP = {
	100001 :"未能接駁八達通收費器",
	100005 :"未能接駁八達通收費器",
	100016 :"讀卡錯誤，請重試",
	100017 :"讀卡錯誤，請重試",
	100019 :"此卡失效",
	100020 :"請再拍卡",
	100021 :"此八達通卡或產品已失效，請聯絡港鐵客務中心",
	100022 :"+++ 請勿取消交易 +++\n交易未能完成\n請通知顧客用同一張卡再次拍卡，以確保交易無誤",
	100024 :"此卡失效",
	100025 :"交易未完成，請重試",
	100032 :"請再拍卡",
	100034 :"讀卡錯誤，請重試",
	100048 :"餘額不足",
	100049 :"儲值額超出上限",
	100051 :"控制台識別號碼不正確",
	100068 :"商戶專有設定檔不存在",
	100072 :"未能支援有關功能",
	101002 :"超出日日賞$ 批額上限",
	101003 :"日日賞$ 餘額不足",
	101004 :"日日賞$ 參數設定錯誤",
	101005 :"錯卡，請重試(八達通號碼88888888)",
	101006 :"計算錯誤",
	101007 :"參數設定錯誤",
	101008 :"計算錯誤",
	101009 :"系統失效",
	101010 :"日日賞$ 功能未啟動",
	101011 :"日日賞$ 功能未啟動",
	101012 :"日日賞$ 功能失效",
	101013 :"超出日日賞$ 累積上限",
	101014 :"兌換日日賞$ 設定失效",
	101015 :"系统檔案無效",
	101016 :"日日賞$ 有效期屆滿",
	101018 :"此卡之日日賞功能經已啟動",
	101101 :"參數設定錯誤",
	101102 :"參數設定錯誤",
	101103 :"交易額超出上限",
	101104 :"超出日日賞$ 批額上限",
	101201 :"電子印花寫入錯誤",
	101202 :"電子印花讀取錯誤",
	101203 :"電子印花號碼失效",
	101204 :"電子印花超出上限",
	101205 :"超出電子印花批額上限",
	101206 :"電子印花校驗錯誤",
	101207 :"電子印花功能尚未啓動",
	101208 :"電子印花參數設定錯誤",
	101209 :"電子印花系统未能使用",
	1000222:"請重試(八達通號碼88888888)"
}

OCT_RESPONSE_ENGLISH_MAP = {
	100001 :"MOP connection failure",
	100005 :"MOP connection failure",
	100016 :"Read card error, retry please",
	100017 :"Read card error, retry please",
	100019 :"Invalid card",
	100020 :"Present card again",
	100021 :"Invalid Octopus, please contact MTR Customer Service Centre",
	100022 :"+++ DO NOT CANCEL THE TXN +++\nTransaction Incomplete\nPlease request customer to present THE same card again to complete THE transaction",
	100024 :"Invalid card",
	100025 :"Incomplete transaction, retry please",
	100032 :"Present card again",
	100034 :"Read card error, retry please",
	100048 :"Insufficient value",
	100049 :"Stored value exceed limit",
	100051 :"Invalid POS controller ID",
	100068 :"No Required List",
	100072 :"Feature Not Supported",
	101002 :"R$ issued exceed quota",
	101003 :"Insufficient R$ value",
	101004 :"Invalid R$ parameter",
	101005 :"Incorrect card, retry please (Octopus no. 88888888)",
	101006 :"Calculation Error",
	101007 :"Invalid Parameter",
	101008 :"Calculation Error",
	101009 :"RMS System Error",
	101010 :"R$ not activated",
	101011 :"R$ not activated",
	101012 :"R$ Invalid",
	101013 :"R$ earned exceed limit",
	101014 :"R$ system block to redeem",
	101015 :"Invalid RMS File",
	101016 :"R$ expired",
	101018 :"Rewards function on Octopus already activated",
	101101 :"Invalid parameter",
	101102 :"Invalid parameter",
	101103 :"BPA value exceed limits",
	101104 :"Issued R$ exceed limits",
	101201 :"",
	101202 :"",
	101203 :"",
	101204 :"",
	101205 :"",
	101206 :"",
	101207 :"",
	101208 :"",
	101209 :"",
	1000222:"Retry please (Octopus no. 88888888)"
}

EDC_RESPONSE_CHINESE_MAP = {
	'000':'交易成功'
}

EDC_RESPONSE_ENGLISH_MAP = {
	'000':'TRANS APPROVED'
}

def packAPIReject(transData,respCode,displayLanguage):
	if displayLanguage == 'E':
		if respCode in API_ENGLISH_MAP:
			transData["RESPMSG"] = API_ENGLISH_MAP[respCode]
		else:
			transData["RESPMSG"] = UNKNOWN_ERROR_ENGLISH
	else:
		if respCode in API_CHINESE_MAP:
			transData["RESPMSG"] = API_CHINESE_MAP[respCode]
		else:
			transData["RESPMSG"] = UNKNOWN_ERROR_CHINESE
